// Grafting is the process of joining two plants together 
//(an upper portion and a lower portion) to grow as one. 
//The upper portion of the plant is known as the scion, 
//which is attached to the lower portion known as the rootstock.

//rs -- rootstock, sc -- scion
#pragma once

#include "data_def_api.h"
using namespace std;

//GCV_DEBUGÿһͼмͼƬʾopencvسִУڲ
// #define GCV_DEBUG
// export 
#define GCV_EXPORTS


#ifdef GCV_EXPORTS
#define GCV_API __declspec(dllexport)
#else
#define GCV_API __declspec(dllimport)
#endif


#ifdef __cplusplus
extern "C"
{
#endif

namespace graft_cv
{
//1 log·
GCV_API	int cv_set_logpath(char*lpath);

//2 logȼ
GCV_API	int cv_set_loglevel(int lev);// 0-debug, 1-info, 2-warning, 3-error

//3 Ƿ洢ͼƬ洢·configureļУtrue--棬false--
GCV_API int cv_init_image_saver();

//4 ʼļʼyml
//  أ 0-  1- ļ 
GCV_API int cv_init(char*conf_file);


//5 ʼͨConfigParamṹֱӸֵò(ڴ)
GCV_API void cv_set_param(ConfigParam&);
GCV_API int cv_set_param_from_file(char*conf_file);

//6 ӿ˳ǰͷ
GCV_API int cv_release();

//7 ȡǰļ·char*Ҫռ㹻ڲûмǷԽ
GCV_API void cv_get_conf_file(char*);

//8 浽ļУǣ
GCV_API void cv_save_param(char* conf_file/*=0*/);

//9 ȡǰò
GCV_API void cv_get_param(ConfigParam&);

//10 ȡǰ汾ţchar*Ҫռ㹻ڲûмǷԽ
GCV_API void get_version(char* buf);


//11 ѿ,ҵץȡλ
//
//  룺 points ---      룬 ָƵָ룬Ϊ3ֵһ飬ṹ[pt0.x, pt0.y, pt0.z, pt1.x, pt1.y,pt1.z], ʱ4ֵһ飨Ӳɼ豸
//         pixel_size ---  룬һƵάȣһ34
//         pt_size-------- 룬 Ϊ2
//         dtype  -------- 룬--0 ľ--1
//
//         posinfo ------- 
//         fn ------------ 룬 pointsָ0fnʱȡļеݣڲԣ֧plyʽ
//				posinfo.rs_pre_x;
//				posinfo.rs_pre_y;
//				posinfo.rs_pre_z;
//				Ϊ0
//  أ 0-  - ʧ
GCV_API int sola_grab_point_rs(float* points, int pixel_size, int pt_size, PositionInfo& posinfo, const char* fn=0);
GCV_API int sola_grab_point_sc(float* points, int pixel_size, int pt_size, PositionInfo& posinfo, const char* fn = 0);


//12  ľŽǶʶ,׷ͼҪͼĽǶȰ˳򣬵һ֡ͼǶΪ0һ֡ͼǶΪ180
//   ÿ׷ͼƬͨposinfoأ
//            1Ҷչposinfo.rs_oa_width
//            2) ʿposinfo.rs_oa_width_base
//            3) ֲy posinfo.rs_oa_stem_y_fork;//ֲy
//	          4) ¶y posinfo.rs_oa_clamp_y_end;//¶y
//            52֡ͼposinfo.pp_images[0]--ľֵָͼ (return image Ϊ trueʱ)
//                        posinfo.pp_images[1]--ʷֵָͼ
//   أ 0-  1- ʧ
//GCV_API int rs_oa_append(ImgInfo*, PositionInfo& posinfo);

//13 ȡľŽǶ
//  ImgInfo* ΪյͼƬ
//  posinfo.rs_oa, ҪתĽǶȣʱΪ

//   أ 0-  1- ʧ
GCV_API int rs_oa_get_result(ImgInfo*, PositionInfo& posinfo);

//14 ľиʶ,
//       posinfo.rs_img_id
//		 posinfo.rs_cut_upoint_x
//		 posinfo.rs_cut_upoint_y
//		 posinfo.rs_stem_diameter
//       posinfo.rs_cut_lpoint_x 
//	     posinfo.rs_cut_lpoint_y
//  	 posinfo.pp_images   (return image Ϊ trueʱ)
//               3ͼƬͼ0ֵͼ񣬺x-rangeֲҲԵ꣨circleģ
//                            ͼ1: Ҷͼѡǵ㣨circleѡ򣬲ο㣨ֲҲԵ꣩
//                            ͼ2Ҷͼи㣬ѡ򣬲ο,е㣨circleģ㣨circleģ
//   أ 0-  1- ʧ
GCV_API int rs_cut_point(ImgInfo*, PositionInfo& posinfo);


//15 ľикʶ,
//		posinfo.rs_becut_upoint_x
//   	posinfo.rs_becut_upoint_y
//  	 posinfo.pp_images   (return image Ϊ trueʱ)
//               1ͼƬͼ0ֵͼ񣬺x-rangeе㣨circleģе㣨circleģ㣨circleģ
//                            
//   أ 0-  1- ʧ
GCV_API int rs_cut_point_reid(ImgInfo*, const char* pre_img_id, PositionInfo& posinfo);

//16 ѿикʶ
//  input:
//       ImgInfo*  --- ͼ
//       sola_type --- 0---磻 1--ľ
//       posinfo---- Ϣ
//
// 
//		е㣬е㣬е
//      //ľ,½λ0
//      posinfo.rs_reid_sola_upoint_x;			//base_y, צy꣬ ľ·צأϷצأ
//      posinfo.rs_reid_sola_upoint_y;			//иybase_yؾ
//      posinfo.rs_reid_sola_cpoint_x;			//--------------------壨Ŀx
//      posinfo.rs_reid_sola_cpoint_y;			//иybase_yؾ
//      posinfo.rs_reid_sola_lpoint_x;			//--------------------壨Ŀx
//      posinfo.rs_reid_sola_lpoint_y;			//иybase_yؾ
//   	
//      //,Ͻλ0
//      posinfo.sc_reid_sola_upoint_x;			//base_y, צy꣬ ľ·צأϷצأ
//      posinfo.sc_reid_sola_upoint_y;			//иybase_yؾ
//      posinfo.sc_reid_sola_cpoint_x;			//--------------------壨Ŀx
//      posinfo.sc_reid_sola_cpoint_y;			//иybase_yؾ
//      posinfo.sc_reid_sola_lpoint_x;			//--------------------壨Ŀx
//      posinfo.sc_reid_sola_lpoint_y;			//иybase_yؾ
//   	
//  	 posinfo.pp_images   (return image Ϊ trueʱ)
//               2ͼƬͼ0ֵͼ
//                           ͼ1 ҶͼԲ
//                            
//   أ 0-  1- ʧ
GCV_API int sola_cut_point_reid_rs(ImgInfo*, PositionInfo& posinfo);
GCV_API int sola_cut_point_reid_sc(ImgInfo*, PositionInfo& posinfo);



//17 иʶ,
//		 posinfo.sc_cut_upoint_x;
//		 posinfo.sc_cut_upoint_y;
//		 posinfo.sc_cut_cpoint_x;
//       posinfo.sc_cut_cpoint_y;
//  	 posinfo.pp_images      (return image Ϊ trueʱ)
//               1ͼƬͼ0ֵͼ񣬺x-rangeֲˮƽߣˮƽߣе㣨circleģе㣨circleģ
//                
//   أ 0-  1- ʧ
GCV_API int sc_cut_point(ImgInfo*, PositionInfo& posinfo);



};//namespace graft_cv

#ifdef __cplusplus
}
#endif